Index: guiframe/data_loader.py
===================================================================
--- guiframe/data_loader.py	(revision e5664f200ab0bbbb596d41d2401b70f2e590920d)
+++ guiframe/data_loader.py	(revision 196608df7381c8545d2f025490ac980982501371)
@@ -7,5 +7,5 @@
 def choose_data_file(parent, location=None):
     path = None
-    if location==None:
+    if location == None:
         location = os.getcwd()
     
@@ -51,5 +51,5 @@
                 else:
                     errdy = 0.0
-                if len(toks)==4:
+                if len(toks) == 4:
                     has_dx = True
                     errdx = float(toks[3])
@@ -63,7 +63,7 @@
                 print "READ ERROR", line
     
-        if has_dy==False:
+        if has_dy == False:
             file_dy = None
-        if has_dx==False:
+        if has_dx == False:
             file_dx = None
             
@@ -100,5 +100,5 @@
     # Load data 
     try:
-        output=L.load(path)
+        output = L.load(path)
     except:
         load_error(sys.exc_value)
@@ -112,13 +112,13 @@
     filename = os.path.basename(path)
     
-    if not  output.__class__.__name__=="list":
+    if not  output.__class__.__name__ == "list":
         ## Creating a Data2D with output
         if hasattr(output,'data'):
-            new_plot = Data2D(image=None,err_image=None)
+            new_plot = Data2D(image=None, err_image=None)
       
         else:
-            msg="Loading 1D data: "
-            wx.PostEvent(parent, StatusEvent(status= "%s %s"%(msg, output.filename)))
-            new_plot = Data1D(x=[], y=[], dx=None,dy= None)
+            msg = "Loading 1D data: "
+            wx.PostEvent(parent, StatusEvent(status="%s %s"%(msg, output.filename)))
+            new_plot = Data1D(x=[], y=[], dx=None, dy=None)
             
         new_plot.copy_from_datainfo(output) 
@@ -126,13 +126,13 @@
       
         ## data 's name
-        if output.filename==None or output.filename=="":
+        if output.filename is None or output.filename == "":
             output.filename = str(filename)
         ## name of the data allow to differentiate data when plotted
-        name= output.filename
+        name = output.filename
         if not name in parent.indice_load_data.keys():
-            parent.indice_load_data[name]=0
+            parent.indice_load_data[name] = 0
         else:
             ## create a copy of the loaded data
-            parent.indice_load_data[name]+=1
+            parent.indice_load_data[name] += 1
             name = name +"[%i]"%parent.indice_load_data[name]
        
@@ -145,13 +145,13 @@
         ##group_id specify on which panel to plot this data
         new_plot.group_id = name
-        new_plot.is_data =True
+        new_plot.is_data = True
         ##post data to plot
         if hasattr(new_plot,"title"):
-            title= str(new_plot.title)
-            if title =="":
-                title=str(name)
+            title = str(new_plot.title)
+            if title == "":
+                title = str(name)
         else:
             title = str(name)
-        wx.PostEvent(parent, NewPlotEvent(plot=new_plot, title= title ))
+        wx.PostEvent(parent, NewPlotEvent(plot=new_plot, title=title ))
         
     ## the output of the loader is a list , some xml files contain more than one data
@@ -160,11 +160,11 @@
         for item in output:
             try:
-                dx=item.dx
-                dxl=item.dxl
-                dxw=item.dxw
+                dx = item.dx
+                dxl = item.dxl
+                dxw = item.dxw
             except:
-                dx=None
-                dxl=None
-                dxw=None
+                dx = None
+                dxl = None
+                dxw = None
 
             new_plot = Data1D(x=item.x,y=item.y,dx=dx,dy=item.dy)
@@ -174,7 +174,7 @@
             new_plot.dxw = dxw
            
-            name= str(item.run[0])
+            name = str(item.run[0])
             if not name in parent.indice_load_data.keys():
-                parent.indice_load_data[name]=0
+                parent.indice_load_data[name] = 0
             else:
                 ## create a copy of the loaded data
@@ -185,6 +185,6 @@
                 # counter arguments stronger? Is this feature developed
                 # to please at least 80% of the users or a special few?
-                parent.indice_load_data[name]+=1
-                name = name +"(copy %i)"%parent.indice_load_data[name]
+                parent.indice_load_data[name] += 1
+                name = name + "(copy %i)"%parent.indice_load_data[name]
                 
             new_plot.name = name
@@ -196,9 +196,9 @@
             new_plot.is_data =True
             if hasattr(item,"title"):
-                title= item.title
-                if title=="":
-                    title=str(name)
+                title = item.title
+                if title == "":
+                    title = str(name)
             else:
-                title= name
+                title = name
             wx.PostEvent(parent, NewPlotEvent(plot=new_plot, title=str(title)))
             i+=1