Index: realspace_modeling/src/sans/simulation/analmodelpy/tests/Make.mm
===================================================================
--- realspace_modeling/src/sans/simulation/analmodelpy/tests/Make.mm	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
+++ realspace_modeling/src/sans/simulation/analmodelpy/tests/Make.mm	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
@@ -0,0 +1,52 @@
+# -*- Makefile -*-
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#                               Michael A.G. Aivazis
+#                        California Institute of Technology
+#                        (C) 1998-2005  All Rights Reserved
+#
+# <LicenseText>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROJ_CXX_INCLUDES += ../../iqPy/libiqPy    \
+		     ../../iqPy/libiqPy/tnt  \
+		     ../libanalmodelpy    \
+		     ../../geoshapespy/libgeoshapespy
+
+PROJECT = SANSsimulation
+PACKAGE = tests
+
+PROJ_CLEAN += $(PROJ_CPPTESTS)
+
+PROJ_PYTESTS = testanal_model.py
+PROJ_CPPTESTS = testanalytical_model
+PROJ_TESTS = $(PROJ_PYTESTS) $(PROJ_CPPTESTS)
+PROJ_LIBRARIES = -L$(BLD_LIBDIR) -lanalmodelpy -liqPy -lgeoshapespy
+
+
+#--------------------------------------------------------------------------
+#
+
+all: $(PROJ_TESTS)
+
+test:
+	for test in $(PROJ_TESTS) ; do $${test}; done
+
+release: tidy
+	cvs release .
+
+update: clean
+	cvs update .
+
+#--------------------------------------------------------------------------
+#
+
+testanalytical_model: testanalytical_model.cc $(BLD_LIBDIR)/libanalmodelpy.$(EXT_SAR)
+	$(CXX) $(CXXFLAGS) $(LCXXFLAGS) -o $@ testanalytical_model.cc $(PROJ_LIBRARIES) 
+
+# version
+# $Id$
+
+# End of file
Index: realspace_modeling/src/sans/simulation/analmodelpy/tests/signon.py
===================================================================
--- realspace_modeling/src/sans/simulation/analmodelpy/tests/signon.py	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
+++ realspace_modeling/src/sans/simulation/analmodelpy/tests/signon.py	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
@@ -0,0 +1,35 @@
+#!/usr/bin/env python
+# 
+#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# 
+#                               Michael A.G. Aivazis
+#                        California Institute of Technology
+#                        (C) 1998-2005  All Rights Reserved
+# 
+#  <LicenseText>
+# 
+#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# 
+
+if __name__ == "__main__":
+
+    import analmodelpy
+    from analmodelpy import analmodelpy as analmodelpymodule
+
+    print "copyright information:"
+    print "   ", analmodelpy.copyright()
+    print "   ", analmodelpymodule.copyright()
+
+    print
+    print "module information:"
+    print "    file:", analmodelpymodule.__file__
+    print "    doc:", analmodelpymodule.__doc__
+    print "    contents:", dir(analmodelpymodule)
+
+    print
+    print analmodelpymodule.hello()
+
+# version
+__id__ = "$Id$"
+
+#  End of file 
Index: realspace_modeling/src/sans/simulation/analmodelpy/tests/testanal_model.py
===================================================================
--- realspace_modeling/src/sans/simulation/analmodelpy/tests/testanal_model.py	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
+++ realspace_modeling/src/sans/simulation/analmodelpy/tests/testanal_model.py	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
@@ -0,0 +1,41 @@
+#!/usr/bin/env python
+# 
+#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# 
+#                               Michael A.G. Aivazis
+#                        California Institute of Technology
+#                        (C) 1998-2005  All Rights Reserved
+# 
+#  <LicenseText>
+# 
+#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# 
+
+if __name__ == "__main__":
+
+    from SANSsimulation import analmodelpy as analmodelpymodule
+    from SANSsimulation import iqPy
+    from SANSsimulation import geoshapespy
+
+    print "copyright information:"
+    print "   ", analmodelpymodule.copyright()
+
+    print
+    print "module information:"
+    print "    file:", analmodelpymodule.__file__
+    print "    doc:", analmodelpymodule.__doc__
+    print "    contents:", dir(analmodelpymodule)
+
+    a = geoshapespy.new_sphere(1.0)
+    iq = iqPy.new_iq(10,0.001, 0.3)
+    anal = analmodelpymodule.new_analmodel(a)
+    analmodelpymodule.CalculateIQ(anal,iq)
+    iqPy.OutputIQ(iq,"out.iq")
+
+
+
+
+# version
+__id__ = "$Id$"
+
+#  End of file 
Index: realspace_modeling/src/sans/simulation/analmodelpy/tests/testanalytical_model.cc
===================================================================
--- realspace_modeling/src/sans/simulation/analmodelpy/tests/testanalytical_model.cc	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
+++ realspace_modeling/src/sans/simulation/analmodelpy/tests/testanalytical_model.cc	(revision 218935b5e9797b5c59db35a4747d4e2385ceed49)
@@ -0,0 +1,22 @@
+#include <cassert>
+#include <iostream>
+#include "analytical_model.h"
+#include "sphere.h"
+
+using namespace std;
+
+void TestAnalyticalModel() {
+  Sphere sphere(1.0);
+  AnalyticalModel am(sphere);
+
+  IQ iq1(10,0.001, 0.3);
+  am.CalculateIQ(&iq1);
+
+  for (int i = 0; i < iq1.iq_data.dim1(); ++i)
+    cout << iq1.iq_data[i][0]<< " " << iq1.iq_data[i][1] <<endl;  
+}
+
+int main(){
+  TestAnalyticalModel();
+  printf("PASS.\n");
+}