Index: sasmodels/models/mono_gauss_coil.py
===================================================================
--- sasmodels/models/mono_gauss_coil.py	(revision 6dd90c1d8aaff9b7299ee215555203db80eaa3a0)
+++ sasmodels/models/mono_gauss_coil.py	(revision 246517d47d1dd00d2038b0bdb50205f635d0c46c)
@@ -14,5 +14,5 @@
 
      *I(q)* = *scale* |cdot| *I* \ :sub:`0` |cdot| *P(q)* + *background*
-	 
+
 where
 
@@ -20,11 +20,11 @@
 
      *P(q)* = 2 [exp(-Z) + Z - 1] / Z \ :sup:`2`
-	 
-	 *Z* = (*q R* \ :sub:`g`)\ :sup:`2`
+
+     *Z* = (*q R* \ :sub:`g`)\ :sup:`2`
 
 and
 
-	 *V* = *M* / (*N*\ :sub:`A` |delta|)
-	 
+     *V* = *M* / (*N*\ :sub:`A` |delta|)
+
 Here, |phi|\ :sub:`poly` is the volume fraction of polymer, *V* is the volume of a polymer coil, *M* is the molecular weight of the polymer, *N*\ :sub:`A` is Avogadro's Number, |delta| is the bulk density of the polymer, |rho|\ :sub:`poly` is the sld of the polymer, |rho|\ :sub:`solv` is the sld of the solvent, and *R*\ :sub:`g` is the radius of gyration of the polymer coil.
 
@@ -52,18 +52,18 @@
 description =  """
     Evaluates the scattering from 
-	monodisperse polymer chains.
+    monodisperse polymer chains.
     """
 category =  "shape-independent"
 
 #             ["name", "units", default, [lower, upper], "type", "description"],
-parameters =  [["i_zero", "1/cm", 1.0, [-inf, inf], "", "Intensity at q=0"],
-               ["radius_gyration", "Ang", 50.0, [0.0, inf], "", "Radius of gyration"]]
+parameters =  [["i_zero", "1/cm", 70.0, [0.0, inf], "", "Intensity at q=0"],
+               ["radius_gyration", "Ang", 75.0, [0.0, inf], "", "Radius of gyration"]]
 
 # NB: Scale and Background are implicit parameters on every model
 def Iq(q, i_zero, radius_gyration):
     # pylint: disable = missing-docstring
-    z = (q * radius_gyration) ** 2
-    if q == 0:
-       inten = 1.0
+    z = (q * radius_gyration) * (q * radius_gyration)
+    if (q == 0).any():
+       inten = i_zero
     else:
        inten = i_zero * 2.0 * (exp(-z) + z - 1.0 ) / (z * z)
@@ -77,6 +77,6 @@
 
 demo =  dict(scale = 1.0,
-            i_zero = 1.0,
-            radius_gyration = 50.0,
+            i_zero = 70.0,
+            radius_gyration = 75.0,
             background = 0.0)
 
@@ -87,5 +87,5 @@
 
 tests =  [
-    [{'scale': 1.0, 'radius_gyration': 50.0, 'background': 0.0},
-     [0.0106939, 0.469418], [0.911141, 0.00362394]],
+    [{'scale': 70.0, 'radius_gyration': 75.0, 'background': 0.0},
+     [0.0106939, 0.469418], [57.1241, 0.112859]],
     ]
Index: sasmodels/models/poly_gauss_coil.py
===================================================================
--- sasmodels/models/poly_gauss_coil.py	(revision 6dd90c1d8aaff9b7299ee215555203db80eaa3a0)
+++ sasmodels/models/poly_gauss_coil.py	(revision 246517d47d1dd00d2038b0bdb50205f635d0c46c)
@@ -14,5 +14,5 @@
 
      *I(q)* = *scale* |cdot| *I* \ :sub:`0` |cdot| *P(q)* + *background*
-	 
+
 where
 
@@ -20,13 +20,13 @@
 
      *P(q)* = 2 [(1 + UZ)\ :sup:`-1/U` + Z - 1] / [(1 + U) Z\ :sup:`2`]
-	 
-	 *Z* = [(*q R*\ :sub:`g`)\ :sup:`2`] / (1 + 2U)
-	 
-	 *U* = (Mw / Mn) - 1 = (*polydispersity ratio*) - 1
+
+     *Z* = [(*q R*\ :sub:`g`)\ :sup:`2`] / (1 + 2U)
+
+     *U* = (Mw / Mn) - 1 = (*polydispersity ratio*) - 1
 
 and
 
-	 *V* = *M* / (*N*\ :sub:`A` |delta|)
-	 
+     *V* = *M* / (*N*\ :sub:`A` |delta|)
+
 Here, |phi|\ :sub:`poly`, is the volume fraction of polymer, *V* is the volume of a polymer coil, *M* is the molecular weight of the polymer, *N*\ :sub:`A` is Avogadro's Number, |delta| is the bulk density of the polymer, |rho|\ :sub:`poly` is the sld of the polymer, |rho|\ :sub:`solv` is the sld of the solvent, and *R*\ :sub:`g` is the radius of gyration of the polymer coil.
 
@@ -57,11 +57,11 @@
 description =  """
     Evaluates the scattering from 
-	polydisperse polymer chains.
+    polydisperse polymer chains.
     """
 category =  "shape-independent"
 
 #             ["name", "units", default, [lower, upper], "type", "description"],
-parameters =  [["i_zero", "1/cm", 1.0, [-inf, inf], "", "Intensity at q=0"],
-               ["radius_gyration", "Ang", 50.0, [0.0, inf], "", "Radius of gyration"],
+parameters =  [["i_zero", "1/cm", 70.0, [0.0, inf], "", "Intensity at q=0"],
+               ["radius_gyration", "Ang", 75.0, [0.0, inf], "", "Radius of gyration"],
                ["polydispersity", "None", 2.0, [1.0, inf], "", "Polymer Mw/Mn"]]
 
@@ -69,15 +69,17 @@
 def Iq(q, i_zero, radius_gyration, polydispersity):
     # pylint: disable = missing-docstring
+    # need to trap the case of the polydispersity being 1 (ie, monodispersity)
     u = polydispersity - 1.0
-    # TO DO
-    # should trap the case of polydispersity = 1 by switching to a taylor expansion
-    minusoneonu = -1.0 / u
-    z = (q * radius_gyration) ** 2 / (1.0 + 2.0 * u)
-    if q == 0:
-        inten = i_zero * 1.0
+    if polydispersity == 1:
+       minusoneonu = -1.0 / u
     else:
-        inten = i_zero * 2.0 * (power((1.0 + u * z),minusoneonu) + z - 1.0 ) / ((1.0 + u) * (z * z))
+       minusoneonu = -1.0 / u
+    z = ((q * radius_gyration) * (q * radius_gyration)) / (1.0 + 2.0 * u)
+    if (q == 0).any():
+       inten = i_zero
+    else:
+       inten = i_zero * 2.0 * (power((1.0 + u * z),minusoneonu) + z - 1.0 ) / ((1.0 + u) * (z * z))
     return inten
-#Iq.vectorized = True # Iq accepts an array of q values
+Iq.vectorized =  True  # Iq accepts an array of q values
 
 def Iqxy(qx, qy, *args):
@@ -87,6 +89,6 @@
 
 demo =  dict(scale = 1.0,
-            i_zero = 1.0,
-            radius_gyration = 50.0,
+            i_zero = 70.0,
+            radius_gyration = 75.0,
             polydispersity = 2.0,
             background = 0.0)
@@ -99,5 +101,5 @@
 
 tests =  [
-    [{'scale': 1.0, 'radius_gyration': 50.0, 'polydispersity': 2.0, 'background': 0.0},
-     [0.0106939, 0.469418], [0.912993, 0.0054163]],
+    [{'scale': 70.0, 'radius_gyration': 75.0, 'polydispersity': 2.0, 'background': 0.0},
+     [0.0106939, 0.469418], [57.6405, 0.169016]],
     ]