Index: src/sas/qtgui/Perspectives/Fitting/ComplexConstraint.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/ComplexConstraint.py	(revision aed053275d5f293f1f6495be4c78e4b18fc52b41)
+++ src/sas/qtgui/Perspectives/Fitting/ComplexConstraint.py	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -13,4 +13,5 @@
 import webbrowser
 
+from sas.qtgui.Perspectives.Fitting import FittingUtilities
 import sas.qtgui.Utilities.GuiUtils as GuiUtils
 ALLOWED_OPERATORS = ['=','<','>','>=','<=']
@@ -32,10 +33,9 @@
         self.operator = '='
 
+        self.warning = self.lblWarning.text()
         self.setupData()
+        self.setupSignals()
         self.setupWidgets()
-        self.setupSignals()
         self.setupTooltip()
-
-        self.setFixedSize(self.minimumSizeHint())
 
         # Default focus is on OK
@@ -101,8 +101,21 @@
         # Find out the signal source
         source = self.sender().objectName()
+        param1 = self.cbParam1.currentText()
+        param2 = self.cbParam2.currentText()
         if source == "cbParam1":
-            self.txtParam.setText(self.tab_names[0] + ":" + self.cbParam1.currentText())
+            self.txtParam.setText(self.tab_names[0] + ":" + param1)
         else:
-            self.txtConstraint.setText(self.tab_names[1] + "." + self.cbParam2.currentText())
+            self.txtConstraint.setText(self.tab_names[1] + "." + param2)
+        # Check if any of the parameters are polydisperse
+        params_list = [param1, param2]
+        all_pars = [tab.model_parameters for tab in self.tabs]
+        is2Ds = [tab.is2D for tab in self.tabs]
+        txt = ""
+        for pars, is2D in zip(all_pars, is2Ds):
+            if any([FittingUtilities.isParamPolydisperse(p, pars, is2D) for p in params_list]):
+                # no parameters are pd - reset the text to not show the warning
+                txt = self.warning
+        self.lblWarning.setText(txt)
+
 
     def onOperatorChange(self, index):
Index: src/sas/qtgui/Perspectives/Fitting/FittingUtilities.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingUtilities.py	(revision 1a15adaa1bbde7cbb9a5f5ff55d61f53d3b88ca7)
+++ src/sas/qtgui/Perspectives/Fitting/FittingUtilities.py	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -781,2 +781,17 @@
 
     return output_string
+
+def isParamPolydisperse(param_name, kernel_params, is2D=False):
+    """
+    Simple lookup for polydispersity for the given param name
+    """
+    parameters = kernel_params.form_volume_parameters
+    if is2D:
+        parameters += kernel_params.orientation_parameters
+    has_poly = False
+    for param in parameters:
+        if param.name==param_name and param.polydisperse:
+            has_poly = True
+            break
+    return has_poly
+
Index: src/sas/qtgui/Perspectives/Fitting/FittingWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 86d320752de5002a8cde6933f80b5cf10ae34dc9)
+++ src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -649,4 +649,8 @@
         # Create and display the widget for param1 and param2
         mc_widget = MultiConstraint(self, params=params_list)
+        # Check if any of the parameters are polydisperse
+        if not np.any([FittingUtilities.isParamPolydisperse(p, self.model_parameters, is2D=self.is2D) for p in params_list]):
+            # no parameters are pd - reset the text to not show the warning
+            mc_widget.lblWarning.setText("")
         if mc_widget.exec_() != QtWidgets.QDialog.Accepted:
             return
Index: src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py	(revision aed053275d5f293f1f6495be4c78e4b18fc52b41)
+++ src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -28,5 +28,4 @@
 
         self.setupUi(self)
-        self.setFixedSize(self.minimumSizeHint())
         self.setModal(True)
         self.params = params
Index: src/sas/qtgui/Perspectives/Fitting/UI/ComplexConstraintUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/ComplexConstraintUI.ui	(revision a90c9c517cd3dc80bd31d2952fa50c9b89997fbb)
+++ src/sas/qtgui/Perspectives/Fitting/UI/ComplexConstraintUI.ui	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>406</width>
-    <height>167</height>
+    <width>463</width>
+    <height>234</height>
    </rect>
   </property>
@@ -21,4 +21,35 @@
      </property>
      <layout class="QGridLayout" name="gridLayout">
+      <item row="1" column="0">
+       <layout class="QHBoxLayout" name="horizontalLayout_2">
+        <item>
+         <widget class="QLabel" name="txtParam">
+          <property name="sizePolicy">
+           <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
+            <horstretch>0</horstretch>
+            <verstretch>0</verstretch>
+           </sizepolicy>
+          </property>
+          <property name="text">
+           <string>param1</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QLabel" name="txtOperator">
+          <property name="text">
+           <string>=</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QLineEdit" name="txtConstraint">
+          <property name="text">
+           <string/>
+          </property>
+         </widget>
+        </item>
+       </layout>
+      </item>
       <item row="0" column="0">
        <layout class="QHBoxLayout" name="horizontalLayout">
@@ -98,52 +129,28 @@
        </layout>
       </item>
-      <item row="1" column="0">
-       <spacer name="verticalSpacer">
-        <property name="orientation">
-         <enum>Qt::Vertical</enum>
-        </property>
-        <property name="sizeHint" stdset="0">
-         <size>
-          <width>20</width>
-          <height>25</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-      <item row="2" column="0">
-       <layout class="QHBoxLayout" name="horizontalLayout_2">
-        <item>
-         <widget class="QLabel" name="txtParam">
-          <property name="sizePolicy">
-           <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
-            <horstretch>0</horstretch>
-            <verstretch>0</verstretch>
-           </sizepolicy>
-          </property>
-          <property name="text">
-           <string>param1</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="txtOperator">
-          <property name="text">
-           <string>=</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLineEdit" name="txtConstraint">
-          <property name="text">
-           <string/>
-          </property>
-         </widget>
-        </item>
-       </layout>
-      </item>
      </layout>
     </widget>
    </item>
    <item row="1" column="0">
+    <widget class="QLabel" name="lblWarning">
+     <property name="text">
+      <string>&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;p&gt;&lt;span style=&quot; color:#ff0000;&quot;&gt;Warning! Polydisperse parameter selected.&lt;br/&gt;&lt;/span&gt;Constraints involving polydisperse parameters only apply to&lt;br/&gt;starting values and are nor re-applied during size or angle polydispersity&lt;br/&gt;integrations. To do which requires creating a custom model.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+     </property>
+    </widget>
+   </item>
+   <item row="2" column="0">
+    <spacer name="verticalSpacer_2">
+     <property name="orientation">
+      <enum>Qt::Vertical</enum>
+     </property>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>20</width>
+       <height>9</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="3" column="0">
     <layout class="QHBoxLayout" name="horizontalLayout_3">
      <item>
Index: src/sas/qtgui/Perspectives/Fitting/UI/MultiConstraintUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/MultiConstraintUI.ui	(revision a90c9c517cd3dc80bd31d2952fa50c9b89997fbb)
+++ src/sas/qtgui/Perspectives/Fitting/UI/MultiConstraintUI.ui	(revision 305114c33963ce5b43f94d3b16fc71e316f72e3a)
@@ -11,9 +11,9 @@
     <y>0</y>
     <width>426</width>
-    <height>162</height>
+    <height>185</height>
    </rect>
   </property>
   <property name="sizePolicy">
-   <sizepolicy hsizetype="Minimum" vsizetype="Minimum">
+   <sizepolicy hsizetype="Minimum" vsizetype="MinimumExpanding">
     <horstretch>0</horstretch>
     <verstretch>0</verstretch>
@@ -119,4 +119,11 @@
    </item>
    <item row="2" column="0">
+    <widget class="QLabel" name="lblWarning">
+     <property name="text">
+      <string>&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;p&gt;&lt;span style=&quot; color:#ff0000;&quot;&gt;Warning! &lt;/span&gt;Constraints involving polydisperse parameters only apply to&lt;br/&gt;starting values and are nor re-applied during size or angle polydispersity&lt;br/&gt;integrations. To do which requires creating a custom model.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+     </property>
+    </widget>
+   </item>
+   <item row="3" column="0">
     <spacer name="verticalSpacer">
      <property name="orientation">
@@ -131,5 +138,5 @@
     </spacer>
    </item>
-   <item row="3" column="0">
+   <item row="4" column="0">
     <layout class="QHBoxLayout" name="horizontalLayout_2">
      <item>